\name{md5}
\alias{md5}
\title{
Compute MD5 hash of a vector.
}
\description{
\code{md5} computes MD5 hash of a vector. Currently the only supported
vectors are integer, real and raw.
}
\usage{
md5(x, raw = FALSE)
}
\arguments{
  \item{x}{vector}    
  \item{raw}{if set to \code{FALSE} then a string (hex) representation
    of the hash is returned, raw vector of 16 bytes otherwise}
}
\details{
The hash is computed on the binary representation of the vector, so the
hash of numeric vectors will differ on machines with a different
endianness (use \code{\link{serialize}} if that is an issue).
}
\value{
If \code{raw} is \code{FALSE} then a character vector of length one with
the one element having 32 characters representing the hash in
hexadecimal notation. Otherwise a raw vector of length 16 representing
the hash.
}
%\references{
%}
%\author{
%}
\note{
  This function is deliberately very simple, does not perform hashing
  of recursive objects and ignores attributes. This is due to the
  original intended use - it is always possible to use
  \code{\link{serialize}} for hashing of complex obejcts.
}
\examples{
## classic examples from the literature to verify correctness:
## should be 9e107d9d372bb6826bd81d3542a419d6
md5(charToRaw("The quick brown fox jumps over the lazy dog"))

## empty vector should be d41d8cd98f00b204e9800998ecf8427e
md5(integer(0))

## other, random examples
md5(1:10)
md5(1:10, TRUE)
}
\keyword{utilities}
